{"openapi":"3.0.0","servers":[{"description":"AASHTO Identity API","url":"https://identity.aashtoware.org"},{"description":"SwaggerHub API Auto Mocking","url":"https://virtserver.swaggerhub.com/iengineering/AASHTOWare_Identity_API/1.0.0"}],"info":{"description":"AASHTO Identity Server (AIS) is a custom identity system implemented for AASHTO using the ASP.NET Identity. The AIS is integrated with other AASHTO web properties that include AASHTO Store, AASHTO Membership Information Management System (AMIMS), and AASTHO Exchange Server. WSP requires a web API interface of the AASHTO Identity Server (AIS) for basic user authentication and registration. The existing AIS web API contains some of the web methods required for this functionality. However, some user information (such as user profile) is stored in AASHTO Store and therefore, the AIS API does not have a web method to retrieve this information directly. Such information is retrieved using the AASHO Store Web API in respective AASHTO web properties. In order to provide complete functionality in a single Web API, iENGINEERING has developed a wrapper implementation as a RESTful API that utilizes the required SOAP based web methods from respective web services internally. <p>This documentation provides API reference for the newly implemented AASHTO Identity Server (AIS) RESTful web API (<a href=\"https://identity.aashtoware.org\" target=\"_blank\">https://identity.aashtoware.org</a>). It includes information on the API security and all the web methods available in the web API. This web API can be utilized by WSP and any other AASHTO contractors for the following functionality.<p> <ol><li>Register new AASHTO users</li><li>Authenticate the AASHTO user by user email address and password</li><li>Change password for AASHTO users</li><li>Check the AASHTO user account by user email address</li><li>Get password for AASHTO users</li><li>Retrieve simple user profile information for AASHTO users</li></ol>","version":"1.0.0","title":"AASHTO Identity RESTful API","contact":{"email":"support@iengineering.com"}},"paths":{"/api/getAuthenticationToken":{"post":{"tags":["API Authentication"],"summary":"API Method to retrieve API Authentication Token.","operationId":"GetAuthenticationToken","description":"This web method is used to get the API authentication token which will be sent with the subsequent web API calls for authentication purposes. It uses the Password Grant Type which is a way to get an OAuth access token given a username and password.","requestBody":{"description":"The Password Grant Type is used for this API. It returns an OAuth access token given a username and password. Three parameters grant_type, username, and password are required for the API authentication. iENGINEERING will provide the username and password to invoke the AASHTO Identity API.","content":{"text/plain":{"schema":{"type":"string","example":"grant_type=password&username=APIUserName&password=APIPassword"}}},"required":true},"responses":{"200":{"description":"Username and password are authenticated, and API token is returned successfully. Token will expire in 60 seconds.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Token"}}}},"400":{"description":"Bad Input Parameter.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Error"}}}},"500":{"description":"The server encountered an internal error and is unable to complete the current request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}}}}},"/user/authenticateUser":{"post":{"tags":["User"],"summary":"API method to authenticate the AASHTO user by user email address and password.","operationId":"AuthenticateUser","description":"This web API method is used to authenticate users from the AASHTO Identity Server based on the provided user email address and password.","responses":{"200":{"description":"User authenticated successfully and \"true\" is returned.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"400":{"description":"Bad Input Parameter.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"500":{"description":"The server encountered an internal error and is unable to complete the current request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/AuthenticateIndividual"}}},"description":"User email address and password fields are required for authentication from the AASHTO Identity Server.","required":true}}},"/user/checkUserExist":{"post":{"tags":["User"],"summary":"API method to check the AASHTO user account by user email address.","operationId":"CheckUserExist","description":"This web method is used to check that the user account already exists in the AASHTO Identity Server with the provided email address.","requestBody":{"description":"User email address is required t to check that the user account already exists in the AASHTO Identity Server.","content":{"text/plain":{"schema":{"type":"string","example":"EmailAddress=john.doe@aashtoware.org"}}},"required":true},"responses":{"200":{"description":"API returns \"true\" if user account already exists with the provided email address and returns \"false\" if user account does not exist with the provided email address in the AASHTO Identity Server.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"400":{"description":"Bad Input Parameter.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"500":{"description":"The server encountered an internal error and is unable to complete the current request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}}}}},"/user/getUserPassword":{"post":{"tags":["User"],"summary":"API method to get password for AASHTO users.","operationId":"GetUserPassword","description":"This method is used to get user password. If the user account exists in the AASHTO Identity Server, then this API web method will return the user password.","requestBody":{"description":"User email address is required to get user password.","content":{"text/plain":{"schema":{"type":"string","example":"EmailAddress=john.doe@aashtoware.org"}}},"required":true},"responses":{"200":{"description":"User password is returned if user exists in the AASHTO Identity Server with the provided email address.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Password"}}}},"400":{"description":"Bad Input Parameter.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"500":{"description":"The server encountered an internal error and is unable to complete the current request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}}}}},"/user/changeUserPassword":{"post":{"tags":["User"],"summary":"API method to change password for AASHTO users.","operationId":"ChangeUserPassword","description":"This method is used to change user password. User email address, old password, and new password will be provided to change the password.","responses":{"200":{"description":"Returns true if user password updated successfully.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"400":{"description":"Bad Input Parameter.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"500":{"description":"The server encountered an internal error and is unable to complete the current request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ChangeIndividualPassword"}}},"description":"User email address, old password, and a new password fields are required to change user password.","required":true}}},"/user/getUserProfile":{"post":{"tags":["User"],"summary":"API method to retrieve simple user profile information for AASHTO users.","operationId":"GetUserProfile","description":"This method is used to get the user basic profile information from the AASHTO Identity Server.","requestBody":{"description":"User email address is required to get user profile.","content":{"text/plain":{"schema":{"type":"string","example":"EmailAddress=john.doe@aashtoware.org"}}},"required":true},"responses":{"200":{"description":"User profile returned successfully if user exist in the AASHTO Identity Server.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/IndividualProfile"}}}},"400":{"description":"Bad Input Parameter.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"500":{"description":"The server encountered an internal error and is unable to complete the current request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}}}}},"/user/addUser":{"post":{"tags":["User"],"summary":"API method to register new AASHTO users.","operationId":"AddUser","description":"This web method is used to register a new user in the AASHTO Identity Server. It will also create the required user profile in the AASHTO Store and associate the user with the AASHTO Membership Information Management System (AMIMS). Please note this method requires several coded values. The Appendix available at the end of this document provides information on the valid values for these coded parameters.","responses":{"200":{"description":"User created successfully and \"true\" is returned.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"400":{"description":"Bad Input Parameter.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}},"500":{"description":"The server encountered an internal error and is unable to complete the current request.","content":{"application/json":{"schema":{"$ref":"#/components/schemas/Message"}}}}},"requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/Individual"}}},"description":"User email address, prefix, first name, last name, employer type, occupation type, organization name, address line1, city, state code, country code, phone and address type fields are required in the Individual object to add a new user in the AASHTO Identity Server.","required":true}}}},"components":{"schemas":{"Message":{"type":"object","properties":{"Message":{"type":"string"}}},"Token":{"type":"object","properties":{"access_token":{"type":"string"},"token_type":{"type":"string"},"expires_in":{"type":"string"}}},"Error":{"type":"object","properties":{"error":{"type":"string"}}},"Password":{"type":"object","properties":{"Password":{"type":"string"}}},"AuthenticateIndividual":{"type":"object","properties":{"EmailAddress":{"type":"string"},"Password":{"type":"string"}}},"ChangeIndividualPassword":{"type":"object","properties":{"EmailAddress":{"type":"string"},"OldPassword":{"type":"string"},"NewPassword":{"type":"string"}}},"Individual":{"type":"object","properties":{"EmailAddress":{"type":"string"},"Password":{"type":"string"},"Prefix":{"type":"string"},"FirstName":{"type":"string"},"MiddleName":{"type":"string"},"LastName":{"type":"string"},"EmployerType":{"type":"string"},"OccupationType":{"type":"string"},"Organization":{"type":"string"},"JobTitle":{"type":"string"},"AddressLine1":{"type":"string"},"AddressLine2":{"type":"string"},"City":{"type":"string"},"State":{"type":"string"},"Zip":{"type":"string"},"Country":{"type":"string"},"Phone":{"type":"string"},"Fax":{"type":"string"},"AddressType":{"type":"string"}}},"IndividualProfile":{"type":"object","properties":{"EmailAddress":{"type":"string"},"Prefix":{"type":"string"},"FirstName":{"type":"string"},"MiddleName":{"type":"string"},"LastName":{"type":"string"},"EmployerType":{"type":"string"},"OccupationType":{"type":"string"},"Organization":{"type":"string"},"JobTitle":{"type":"string"},"AddressLine1":{"type":"string"},"AddressLine2":{"type":"string"},"City":{"type":"string"},"State":{"type":"string"},"Zip":{"type":"string"},"Country":{"type":"string"},"Phone":{"type":"string"},"Fax":{"type":"string"},"AddressType":{"type":"string"}}}}}}